openapi: '3.1.2' info: title: Elastic Cloud API description: "This RESTful API enables you to perform most of the operations available in the UI console through API calls.\n\nYou can [create an API key](https://www.elastic.co/guide/en/cloud/current/ec-api-authentication.html) to quickly and easily authenticate, then use the API to create and manage deployments, configure remote clusters, set up traffic filters, manage extensions, and much more.\nAccess the API from its base URL at `api.elastic-cloud.com`.\n\nTo manage your serverless projects, use the [Elastic Cloud Serverless API](https://www.elastic.co/docs/api/doc/elastic-cloud-serverless).\n\n## Documentation source and versions\n\nThis documentation is derived from https://api.elastic-cloud.com/api/v1/api-docs-user/swagger.json.\nIt is provided under license [Attribution-NonCommercial-NoDerivatives 4.0 International](https://creativecommons.org/licenses/by-nc-nd/4.0/).\n" termsOfService: '' version: '1' x-doc-license: name: Attribution-NonCommercial-NoDerivatives 4.0 International url: https://creativecommons.org/licenses/by-nc-nd/4.0/ x-feedbackLink: label: Feedback url: https://github.com/elastic/docs-content/issues/new?assignees=&labels=feedback%2Ccommunity&projects=&template=api-feedback.yaml&title=%5BFeedback%5D%3A+ servers: - url: https://api.elastic-cloud.com/api/v1 paths: /account: get: tags: - Accounts summary: Fetch current account information description: Fetch current account information. operationId: get-current-account responses: '200': description: Account fetched successfully content: application/json: schema: $ref: '#/components/schemas/AccountResponse' '404': description: 'Account not found. (code: `accounts.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - accounts.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Accounts put: tags: - Accounts summary: Updates the current account description: Updates the current account. operationId: update-current-account requestBody: description: the current account content: application/json: schema: $ref: '#/components/schemas/AccountUpdateRequest' required: true x-bodyName: body responses: '200': description: Account updated successfully content: application/json: schema: $ref: '#/components/schemas/AccountResponse' '404': description: 'Account not found. (code: `accounts.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - accounts.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Accounts patch: tags: - Accounts summary: Updates the current account description: Updates the current account. operationId: patch-current-account requestBody: description: 'All changes in the specified object are applied to the current account according to the JSON Merge Patch processing rules. Omitting existing fields causes the same values to be reapplied. Specifying a `null` value reverts the field to the default value, or removes the field when no default value exists.' content: application/json: schema: type: string required: true x-bodyName: body responses: '200': description: Account updated successfully content: application/json: schema: $ref: '#/components/schemas/AccountResponse' '404': description: 'Account not found. (code: `accounts.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - accounts.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Accounts '/billing/costs/{organization_id}': get: tags: - BillingCostsAnalysis summary: Get costs overview for the organization. Currently unavailable in self-hosted ECE. description: Retrieves an overview of the costs by organization ID. operationId: get-costs-overview parameters: - name: organization_id in: path description: Identifier for the organization required: true schema: type: string - name: from in: query description: A datetime for the beginning of the desired range for which to fetch costs. Defaults to start of current month. schema: type: string - name: to in: query description: A datetime for the end of the desired range for which to fetch costs. Defaults to the current date. schema: type: string responses: '200': description: Top-level cost overview for the organization content: application/json: schema: $ref: '#/components/schemas/CostsOverview' '400': description: 'The specified date range is invalid. (code: `costs.invalid_date_range`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - costs.invalid_date_range type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '403': description: 'The current user does not have access to the requested organization. (code: `organization.invalid_access`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - organization.invalid_access type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'Organization not found. (code: `organization.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - organization.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'An error occurred when fetching an overview of the costs for the organization. (code: `billing_service.failed_request`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - billing_service.failed_request type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' deprecated: true x-doc: tag: Billing Costs Analysis '/billing/costs/{organization_id}/charts': get: tags: - BillingCostsAnalysis summary: Get charts for the organization. Currently unavailable in self-hosted ECE. description: Retrieves the usage charts for the organization. operationId: get-costs-charts parameters: - name: organization_id in: path description: Identifier for the organization required: true schema: type: string - name: from in: query description: A datetime for the beginning of the desired range for which to fetch costs. Defaults to start of current month. schema: type: string - name: to in: query description: A datetime for the end of the desired range for which to fetch costs. Defaults to the current date. schema: type: string - name: bucketing_strategy in: query description: The desired bucketing strategy for the charts. Defaults to `daily`. schema: enum: - daily - monthly type: string default: daily responses: '200': description: The usage charts of an organization. content: application/json: schema: $ref: '#/components/schemas/ChartItems' '400': description: 'The specified date range is invalid. (code: `costs.invalid_date_range`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - costs.invalid_date_range type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '403': description: 'The current user does not have access to the requested organization. (code: `organization.invalid_access`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - organization.invalid_access type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'Organization not found. (code: `organization.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - organization.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '429': description: 'Too many requests. (code: `billing_service.rate_limited`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - billing_service.rate_limited type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'Error fetching the itemized costs for the organization. (code: `billing_service.failed_request`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - billing_service.failed_request type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' deprecated: true x-doc: tag: Billing Costs Analysis '/billing/costs/{organization_id}/deployments': get: tags: - BillingCostsAnalysis summary: Get deployments costs for the organization. Currently unavailable in self-hosted ECE. description: Retrieves the costs associated with all deployments for the organization. operationId: get-costs-deployments parameters: - name: organization_id in: path description: Identifier for the organization required: true schema: type: string - name: from in: query description: A datetime for the beginning of the desired range for which to fetch activity. Defaults to start of current month. schema: type: string - name: to in: query description: A datetime for the end of the desired range for which to fetch activity. Defaults to the current date. schema: type: string - name: Accept in: header description: Accept header containing the content preference. schema: type: string responses: '200': description: The costs associated to a set of products content: application/json: schema: $ref: '#/components/schemas/DeploymentsCosts' '400': description: 'Invalid date range specified. (code: `costs.invalid_date_range`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - costs.invalid_date_range type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '403': description: 'The current user does not have access to the requested organization. (code: `organization.invalid_access`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - organization.invalid_access type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'Organization not found. (code: `organization.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - organization.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'An error occurred when fetching the costs associated with all deployments for the organization. (code: `billing_service.failed_request`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - billing_service.failed_request type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' deprecated: true x-doc: tag: Billing Costs Analysis '/billing/costs/{organization_id}/deployments/{deployment_id}/charts': get: tags: - BillingCostsAnalysis summary: Get charts by deployment. Currently unavailable in self-hosted ECE. description: Retrieves the usage charts for the given deployment. operationId: get-costs-charts-by-deployment parameters: - name: organization_id in: path description: Identifier for the organization required: true schema: type: string - name: deployment_id in: path description: Id of a Deployment required: true schema: type: string - name: from in: query description: A datetime for the beginning of the desired range for which to fetch costs. Defaults to start of current month. schema: type: string - name: to in: query description: A datetime for the end of the desired range for which to fetch costs. Defaults to the current date. schema: type: string - name: bucketing_strategy in: query description: The desired bucketing strategy for the charts. Defaults to `daily`. schema: enum: - daily - monthly type: string default: daily responses: '200': description: The usage charts of a deployment. content: application/json: schema: $ref: '#/components/schemas/ChartItems' '400': description: 'The specified date range is invalid. (code: `costs.invalid_date_range`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - costs.invalid_date_range type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '403': description: 'The current user does not have access to the requested organization. (code: `organization.invalid_access`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - organization.invalid_access type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'Organization not found. (code: `organization.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - organization.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '429': description: 'Too many requests. (code: `billing_service.rate_limited`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - billing_service.rate_limited type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'Error fetching the itemized costs for the organization. (code: `billing_service.failed_request`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - billing_service.failed_request type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' deprecated: true x-doc: tag: Billing Costs Analysis '/billing/costs/{organization_id}/deployments/{deployment_id}/items': get: tags: - BillingCostsAnalysis summary: Get itemized costs by deployments. Currently unavailable in self-hosted ECE. description: Retrieves the itemized costs for the given deployment. operationId: get-costs-items-by-deployment parameters: - name: organization_id in: path description: Identifier for the organization required: true schema: type: string - name: deployment_id in: path description: Id of a Deployment required: true schema: type: string - name: from in: query description: A datetime for the beginning of the desired range for which to fetch costs. Defaults to start of current month. schema: type: string - name: to in: query description: A datetime for the end of the desired range for which to fetch costs. Defaults to the current date. schema: type: string - name: Accept in: header description: Determines the response body format. Can be either application/json or text/csv. schema: type: string responses: '200': description: The costs associated to a set items billed for a single deployment. content: application/json: schema: $ref: '#/components/schemas/ItemsCosts' '400': description: 'The specified date range is invalid. (code: `costs.invalid_date_range`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - costs.invalid_date_range type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '403': description: 'The current user does not have access to the requested organization. (code: `organization.invalid_access`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - organization.invalid_access type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: "* The organization was not found. (code: `organization.not_found`)\n* The Elasticsearch cluster was not found. (code: `billing_service.es_cluster_id_not_found`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - organization.not_found - billing_service.es_cluster_id_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'An error occurred when fetching the itemized costs for the given deployment of the organization. (code: `billing_service.failed_request`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - billing_service.failed_request type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' deprecated: true x-doc: tag: Billing Costs Analysis '/billing/costs/{organization_id}/items': get: tags: - BillingCostsAnalysis summary: Get itemized costs for the organization. Currently unavailable in self-hosted ECE. description: Retrieves the itemized costs for the organization. operationId: get-costs-items parameters: - name: organization_id in: path description: Identifier for the organization required: true schema: type: string - name: from in: query description: A datetime for the beginning of the desired range for which to fetch costs. Defaults to start of current month. schema: type: string - name: to in: query description: A datetime for the end of the desired range for which to fetch costs. Defaults to the current date. schema: type: string responses: '200': description: The costs associated to a set of items content: application/json: schema: $ref: '#/components/schemas/ItemsCosts' '400': description: 'The specified date range is invalid. (code: `costs.invalid_date_range`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - costs.invalid_date_range type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '403': description: 'The current user does not have access to the requested organization. (code: `organization.invalid_access`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - organization.invalid_access type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'Organization not found. (code: `organization.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - organization.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'Error fetching the itemized costs for the organization. (code: `billing_service.failed_request`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - billing_service.failed_request type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' deprecated: true x-doc: tag: Billing Costs Analysis /deployments: get: tags: - Deployments summary: List Deployments description: List Deployments. operationId: list-deployments responses: '200': description: The list of deployments that belong to the authenticated user. content: application/json: schema: $ref: '#/components/schemas/DeploymentsListResponse' '401': description: You are not authorized to perform this action. content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - CRUD post: tags: - Deployments summary: Create Deployment description: Creates a Deployment. operationId: create-deployment parameters: - name: request_id in: query description: 'An optional idempotency token - if two create requests share the same request_id token (min size 32 characters, max 128) then only one deployment will be created, the second request will return the info of that deployment (in the same format described below, but with blanks for auth-related fields)' schema: type: string - name: validate_only in: query description: 'If true, will just validate the Deployment definition but will not perform the creation' schema: type: boolean default: false - name: template_id in: query description: 'An optional template id - if present, the referenced template will be used to fill in the resources field of the deployment creation request. If any resources are present in the request together with the template, the ones coming in the request will prevail and no merging with the template will be performed.' schema: type: string requestBody: description: The deployment definition content: application/json: schema: $ref: '#/components/schemas/DeploymentCreateRequest' required: true x-bodyName: body responses: '200': description: The request was valid (used when validate_only is true). content: application/json: schema: $ref: '#/components/schemas/DeploymentCreateResponse' '201': description: The request was valid and a new deployment was created headers: x-cloud-resource-version: description: 'The resource version, which is used to avoid update conflicts with concurrent operations' schema: type: string x-cloud-resource-created: description: The date-time when the resource was created (ISO format relative to UTC) schema: type: string x-cloud-resource-last-modified: description: The date-time when the resource was last modified (ISO format relative to UTC) schema: type: string content: application/json: schema: $ref: '#/components/schemas/DeploymentCreateResponse' '202': description: The request was valid and deployment creation had already been started. content: application/json: schema: $ref: '#/components/schemas/DeploymentCreateResponse' '400': description: The deployment request had errors. content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '401': description: You are not authorized to perform this action. content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - CRUD /deployments/_search: post: tags: - Deployments summary: Search Deployments description: Retrieves the information for all of the deployments that match the specified query. operationId: search-deployments parameters: - name: minimal_metadata in: query description: Comma separated list of attributes to include in response for deployments found. Useful for reducing response size when retrieving many deployments. Use of this parameter moves the result to the minimal_metadata section of the response. schema: type: string requestBody: description: '(Optional) The search query to run. When not specified, all of the deployments are matched.' content: application/json: schema: $ref: '#/components/schemas/SearchRequest' x-bodyName: body responses: '200': description: The list of deployments that match the specified query and belong to the authenticated user. headers: x-cloud-resource-version: description: 'The resource version, which is used to avoid update conflicts with concurrent operations' schema: type: string x-cloud-resource-created: description: The date-time when the resource was created (ISO format relative to UTC) schema: type: string x-cloud-resource-last-modified: description: The date-time when the resource was last modified (ISO format relative to UTC) schema: type: string content: application/json: schema: $ref: '#/components/schemas/DeploymentsSearchResponse' x-doc: tag: Deployment - Commands /deployments/eligible-remote-clusters: post: tags: - Deployments summary: Get eligible remote clusters description: Returns the list of deployments which contain eligible remote clusters for a specific version. operationId: search-eligible-remote-clusters parameters: - name: version in: query description: The version of the Elasticsearch cluster cluster that will potentially be configured to have remote clusters. required: true schema: type: string requestBody: description: '(Optional) The search query to run against all deployments containing eligible remote clusters. When not specified, all the eligible deployments are matched.' content: application/json: schema: $ref: '#/components/schemas/SearchRequest' x-bodyName: body responses: '200': description: List of deployments which contains eligible remote clusters for a specific version content: application/json: schema: $ref: '#/components/schemas/DeploymentsSearchResponse' '400': description: 'The provided version is invalid. (code: `stackpack.invalid_version`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - stackpack.invalid_version type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - Remote Clusters /deployments/extensions: get: tags: - Extensions summary: List Extensions description: Retrieves all of the available extensions. operationId: list-extensions responses: '200': description: The extensions that are available content: application/json: schema: $ref: '#/components/schemas/Extensions' x-doc: tag: Deployments - Extensions post: tags: - Extensions summary: Create an extension description: "Creates the extension.\n The extensions API supports two types of usage patterns.\n A). Specify a `download_url`, http or https URL, where the extension is currently hosted. This will result in extension being copied to elastic repository.\n B). Create only the extension metadata using the `POST` endpoint and then use `PUT` to upload the extension file. Leave the `download_url` unspecified in this case.\n" operationId: create-extension requestBody: description: the data that creates the extension content: application/json: schema: $ref: '#/components/schemas/CreateExtensionRequest' required: true x-bodyName: body responses: '201': description: The extension that was just created. headers: x-cloud-resource-version: description: 'The resource version, which is used to avoid update conflicts with concurrent operations' schema: type: string x-cloud-resource-created: description: The date-time when the resource was created (ISO format relative to UTC) schema: type: string x-cloud-resource-last-modified: description: The date-time when the resource was last modified (ISO format relative to UTC) schema: type: string content: application/json: schema: $ref: '#/components/schemas/Extension' '400': description: 'Could not download the extension from the specified URL. (code: `extensions.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'Your current session does not have a user id associated with it. (code: `extensions.no_user_id`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.no_user_id type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '409': description: 'An extension already exists with the generated id. Please try again. (code: `extensions.id_already_exists`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.id_already_exists type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '503': description: 'The extension download service is currently at capacity. Please retry shortly. (code: `extensions.download_service_busy`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.download_service_busy type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Extensions '/deployments/extensions/{extension_id}': get: tags: - Extensions summary: Get Extension description: Retrieves an extension. operationId: get-extension parameters: - name: extension_id in: path description: Id of an extension required: true schema: type: string - name: include_deployments in: query description: Include deployments referencing this extension. Up to only 10000 deployments will be included. schema: type: boolean default: false responses: '200': description: The Extension headers: x-cloud-resource-version: description: 'The resource version, which is used to avoid update conflicts with concurrent operations' schema: type: string x-cloud-resource-created: description: The date-time when the resource was created (ISO format relative to UTC) schema: type: string x-cloud-resource-last-modified: description: The date-time when the resource was last modified (ISO format relative to UTC) schema: type: string content: application/json: schema: $ref: '#/components/schemas/Extension' '404': description: 'The extension requested does not exist. (code: `extensions.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Extensions post: tags: - Extensions summary: Update Extension description: Updates an extension. operationId: update-extension parameters: - name: extension_id in: path description: Id of an extension required: true schema: type: string requestBody: description: The extension update data. content: application/json: schema: $ref: '#/components/schemas/UpdateExtensionRequest' required: true x-bodyName: body responses: '200': description: Extension updated successfully. headers: x-cloud-resource-version: description: 'The resource version, which is used to avoid update conflicts with concurrent operations' schema: type: string x-cloud-resource-created: description: The date-time when the resource was created (ISO format relative to UTC) schema: type: string x-cloud-resource-last-modified: description: The date-time when the resource was last modified (ISO format relative to UTC) schema: type: string content: application/json: schema: $ref: '#/components/schemas/Extension' '400': description: 'Could not download the extension from the specified URL. (code: `extensions.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '401': description: "* The extension does not belong to you. (code: `extensions.unauthorised`)\n* Your current session does not have a user id associated with it. (code: `extensions.no_user_id`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.unauthorised - extensions.no_user_id type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'The extension you want does not exist. (code: `extensions.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '409': description: 'The version you sent does not match the persisted version. (code: `extensions.version_conflict`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.version_conflict type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '503': description: 'The extension download service is currently at capacity. Please retry shortly. (code: `extensions.download_service_busy`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.download_service_busy type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Extensions put: tags: - Extensions summary: Uploads the Extension description: Uploads archive for an extension. operationId: upload-extension parameters: - name: extension_id in: path description: Id of an extension required: true schema: type: string requestBody: content: multipart/form-data: schema: required: - file type: object properties: file: type: string description: Zip file that contains the extension format: binary responses: '200': description: Archive uploaded successfully. headers: x-cloud-resource-version: description: 'The resource version, which is used to avoid update conflicts with concurrent operations' schema: type: string x-cloud-resource-created: description: The date-time when the resource was created (ISO format relative to UTC) schema: type: string x-cloud-resource-last-modified: description: The date-time when the resource was last modified (ISO format relative to UTC) schema: type: string content: application/json: schema: $ref: '#/components/schemas/Extension' '400': description: 'Could not accept the extensions file. (code: `extensions.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '401': description: "* The extension does not belong to you. (code: `extensions.unauthorised`)\n* Your current session does not have a user id associated with it. (code: `extensions.no_user_id`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.unauthorised - extensions.no_user_id type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'The extension you want does not exist. (code: `extensions.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '503': description: 'The extension download service is currently at capacity. Please retry shortly. (code: `extensions.download_service_busy`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.download_service_busy type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Extensions delete: tags: - Extensions summary: Delete Extension description: Deletes a Extension. operationId: delete-extension parameters: - name: extension_id in: path description: Id of an extension required: true schema: type: string responses: '200': description: Extension deleted successfully. headers: x-cloud-resource-version: description: 'The resource version, which is used to avoid update conflicts with concurrent operations' schema: type: string x-cloud-resource-created: description: The date-time when the resource was created (ISO format relative to UTC) schema: type: string x-cloud-resource-last-modified: description: The date-time when the resource was last modified (ISO format relative to UTC) schema: type: string content: application/json: schema: $ref: '#/components/schemas/EmptyResponse' '401': description: "* The extension does not belong to you. (code: `extensions.unauthorised`)\n* Your current session does not have a user id associated with it. (code: `extensions.no_user_id`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.unauthorised - extensions.no_user_id type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'The extension requested does not exist. (code: `extensions.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '409': description: 'The version you sent does not match the persisted version. (code: `extensions.version_conflict`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - extensions.version_conflict type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Extensions /deployments/templates: get: tags: - DeploymentTemplates summary: Get deployment templates description: Retrieves all deployment templates. operationId: get-deployment-templates-v2 parameters: - name: metadata in: query description: An optional key/value pair in the form of (key:value) that will act as a filter and exclude any templates that do not have a matching metadata item associated. schema: type: string - name: show_instance_configurations in: query description: 'If true, will return details for each instance configuration referenced by the template.' schema: type: boolean default: true - name: show_max_zones in: query description: 'If true, will populate the max_zones field in the instance configurations. Only relevant if show_instance_configurations=true.' schema: type: boolean default: false - name: stack_version in: query description: 'If present, it will cause the returned deployment templates to be adapted to return only the elements allowed in that version.' schema: type: string - name: hide_deprecated in: query description: 'If true, templates flagged as deprecated will NOT be returned.' schema: type: boolean default: false - name: region in: query description: Region of the deployment templates required: true schema: type: string responses: '200': description: The deployment templates were returned successfully. content: application/json: schema: type: array items: $ref: '#/components/schemas/DeploymentTemplateInfoV2' '400': description: 'The requested region was not found. (code: `templates.region_not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - templates.region_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '401': description: 'The user is not authorized to access requested region. (code: `templates.region_not_allowed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - templates.region_not_allowed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Templates '/deployments/templates/{template_id}': get: tags: - DeploymentTemplates summary: Get deployment template description: Retrieves a deployment template by id. operationId: get-deployment-template-v2 parameters: - name: template_id in: path description: The identifier for the deployment template. required: true schema: type: string - name: show_instance_configurations in: query description: 'If true, will return details for each instance configuration referenced by the template.' schema: type: boolean default: true - name: show_max_zones in: query description: 'If true, will populate the max_zones field in the instance configurations. Only relevant if show_instance_configurations=true.' schema: type: boolean default: false - name: stack_version in: query description: 'If present, it will cause the returned deployment template to be adapted to return only the elements allowed in that version.' schema: type: string - name: region in: query description: Region of the deployment template required: true schema: type: string responses: '200': description: The deployment template was found and returned successfully. content: application/json: schema: $ref: '#/components/schemas/DeploymentTemplateInfoV2' '400': description: 'The requested region is not supported. (code: `templates.region_not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - templates.region_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '401': description: 'The user is not authorized to access requested region. (code: `templates.region_not_allowed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - templates.region_not_allowed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'The deployment template specified by {template_id} cannot be found. (code: `templates.template_not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - templates.template_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Templates '/deployments/traffic-filter/associations/{association_type}/{associated_entity_id}/rulesets': get: tags: - DeploymentsTrafficFilter summary: Get associated rulesets description: Retrieves the rulesets associated with a deployment. operationId: get-traffic-filter-deployment-ruleset-associations parameters: - name: association_type in: path description: Association type required: true schema: type: string - name: associated_entity_id in: path description: Associated entity ID required: true schema: type: string responses: '200': description: Rulesets in the deployment were successfully returned content: application/json: schema: $ref: '#/components/schemas/TrafficFilterSettings' '400': description: 'Invalid association type. (code: `traffic_filter.invalid_association_type`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.invalid_association_type type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'Error fetching traffic filter rulesets. (code: `traffic_filter.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Traffic Filter - Associations /deployments/traffic-filter/link-ids: get: tags: - DeploymentsTrafficFilter summary: List traffic filter claimed link id description: List all of the traffic filter claimed link id. operationId: get-traffic-filter-claimed-link-ids parameters: - name: region in: query description: If provided limits the claimed id to that region only. schema: type: string - name: organization_id in: query description: Retrieves a list of resources that are associated to the specified organization ID. It only takes effect if the user is an admin. schema: type: string responses: '200': description: The collection of traffic filter claimed link id content: application/json: schema: $ref: '#/components/schemas/TrafficFilterClaimedLinkIds' '500': description: 'Error fetching traffic filter claimed link ids. (code: `traffic_filter_claimed_link_id.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter_claimed_link_id.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Traffic Filter Claimed Link Id /deployments/traffic-filter/link-ids/_claim: post: tags: - DeploymentsTrafficFilter summary: Claim a link id description: Claim the ownership of a link id. operationId: claim-traffic-filter-link-id requestBody: description: The specification for traffic filter claimed link id. content: application/json: schema: $ref: '#/components/schemas/TrafficFilterClaimedLinkIdRequest' required: true x-bodyName: body responses: '201': description: The ruleset definition is valid and the creation has started. content: application/json: schema: $ref: '#/components/schemas/TrafficFilterClaimedLinkIdInfo' '500': description: 'Error creating the traffic filter ruleset. (code: `traffic_filter_claimed_link_id.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter_claimed_link_id.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Traffic Filter Claimed Link Id /deployments/traffic-filter/link-ids/_unclaim: post: tags: - DeploymentsTrafficFilter summary: Unclaims a link id description: Unclaims the ownership of a link id. operationId: unclaim-traffic-filter-link-id requestBody: description: The specification for traffic filter claimed link id. content: application/json: schema: $ref: '#/components/schemas/TrafficFilterClaimedLinkIdRequest' required: true x-bodyName: body responses: '200': description: The claimed link id was successfully deleted. content: application/json: schema: $ref: '#/components/schemas/EmptyResponse' '400': description: 'Error validating the request. (code: `traffic_filter_claimed_link_id.invalid_input`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter_claimed_link_id.invalid_input type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'Error deleting the traffic filter claimed link id. (code: `traffic_filter_claimed_link_id.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter_claimed_link_id.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Traffic Filter Claimed Link Id /deployments/traffic-filter/rulesets: get: tags: - DeploymentsTrafficFilter summary: List traffic filter rulesets description: List all of the traffic filter rulesets. operationId: get-traffic-filter-rulesets parameters: - name: include_associations in: query description: Retrieves a list of resources that are associated to the specified ruleset. schema: type: boolean default: false - name: region in: query description: If provided limits the rulesets to that region only. schema: type: string - name: organization_id in: query description: Retrieves a list of resources that are associated to the specified organization ID. It only takes effect if the user is an admin. schema: type: string responses: '200': description: The collection of traffic filter routes content: application/json: schema: $ref: '#/components/schemas/TrafficFilterRulesets' '500': description: 'Error fetching traffic filter rulesets. (code: `traffic_filter.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Traffic Filter - CRUD post: tags: - DeploymentsTrafficFilter summary: Create a ruleset description: Creates a ruleset that consists of a set of rules. operationId: create-traffic-filter-ruleset requestBody: description: The specification for traffic filter ruleset. content: application/json: schema: $ref: '#/components/schemas/TrafficFilterRulesetRequest' required: true x-bodyName: body responses: '201': description: The ruleset definition is valid and the creation has started. content: application/json: schema: $ref: '#/components/schemas/TrafficFilterRulesetResponse' '500': description: 'Error creating the traffic filter ruleset. (code: `traffic_filter.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Traffic Filter - CRUD '/deployments/traffic-filter/rulesets/{ruleset_id}': get: tags: - DeploymentsTrafficFilter summary: Retrieves the ruleset by ID. description: Retrieves a list of resources that are associated to the specified ruleset. operationId: get-traffic-filter-ruleset parameters: - name: ruleset_id in: path description: The mandatory ruleset ID. required: true schema: type: string - name: include_associations in: query description: Retrieves a list of resources that are associated to the specified ruleset. schema: type: boolean default: false responses: '200': description: The container for a set of traffic filter rules. content: application/json: schema: $ref: '#/components/schemas/TrafficFilterRulesetInfo' '404': description: 'The traffic filter ruleset specified by {ruleset_id} cannot be found. (code: `traffic_filter.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'Error reading the traffic filter ruleset. (code: `traffic_filter.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Traffic Filter - CRUD put: tags: - DeploymentsTrafficFilter summary: Updates a ruleset description: Updates the ruleset with the definition. operationId: update-traffic-filter-ruleset parameters: - name: ruleset_id in: path description: The mandatory ruleset ID. required: true schema: type: string requestBody: description: The specification for traffic filter ruleset. content: application/json: schema: $ref: '#/components/schemas/TrafficFilterRulesetRequest' required: true x-bodyName: body responses: '200': description: The ruleset definition was valid and the update has started. content: application/json: schema: $ref: '#/components/schemas/TrafficFilterRulesetResponse' '404': description: 'The traffic filter ruleset specified by {ruleset_id} cannot be found. (code: `traffic_filter.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'Error reading the traffic filter ruleset. (code: `traffic_filter.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Traffic Filter - CRUD delete: tags: - DeploymentsTrafficFilter summary: Delete a ruleset description: Deletes the ruleset by ID. operationId: delete-traffic-filter-ruleset parameters: - name: ruleset_id in: path description: The mandatory ruleset ID. required: true schema: type: string - name: ignore_associations in: query description: 'When true, ignores the associations and deletes the ruleset. When false, recognizes the associations, which prevents the deletion of the rule set.' schema: type: boolean default: false responses: '200': description: The traffic filter ruleset was successfully deleted. content: application/json: schema: $ref: '#/components/schemas/EmptyResponse' '404': description: 'The traffic filter ruleset specified by {ruleset_id} cannot be found. (code: `traffic_filter.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'Error deleting the traffic filter ruleset. (code: `traffic_filter.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Traffic Filter - CRUD '/deployments/traffic-filter/rulesets/{ruleset_id}/associations': get: tags: - DeploymentsTrafficFilter summary: Get associated deployments description: Retrieves a list of deployments that are associated to the specified ruleset. operationId: get-traffic-filter-ruleset-deployment-associations parameters: - name: ruleset_id in: path description: The mandatory ruleset ID. required: true schema: type: string responses: '200': description: Associations referred by traffic filter rulesets were successfully returned content: application/json: schema: $ref: '#/components/schemas/RulesetAssociations' '500': description: 'Error fetching deployments. (code: `traffic_filter.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Traffic Filter - Associations post: tags: - DeploymentsTrafficFilter summary: Create ruleset association description: Applies the ruleset to the specified deployment. operationId: create-traffic-filter-ruleset-association parameters: - name: ruleset_id in: path description: The mandatory ruleset ID. required: true schema: type: string requestBody: description: Mandatory ruleset association description content: application/json: schema: $ref: '#/components/schemas/FilterAssociation' required: true x-bodyName: body responses: '200': description: Create association request was valid and the association already exists content: application/json: schema: $ref: '#/components/schemas/EmptyResponse' '201': description: Create association request was valid and the association has been created content: application/json: schema: $ref: '#/components/schemas/EmptyResponse' '403': description: 'The ruleset and deployment belong to different organizations. (code: `traffic_filter.organization_mismatch`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.organization_mismatch type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'The traffic filter ruleset specified by {ruleset_id} cannot be found. (code: `traffic_filter.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'Creation failed. (code: `traffic_filter.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Traffic Filter - Associations '/deployments/traffic-filter/rulesets/{ruleset_id}/associations/{association_type}/{associated_entity_id}': delete: tags: - DeploymentsTrafficFilter summary: Delete ruleset association description: Deletes the traffic rules in the ruleset from the deployment. operationId: delete-traffic-filter-ruleset-association parameters: - name: ruleset_id in: path description: The mandatory ruleset ID. required: true schema: type: string - name: association_type in: path description: Association type required: true schema: type: string - name: associated_entity_id in: path description: Associated entity ID required: true schema: type: string responses: '200': description: Delete association request was valid and the association has been deleted content: application/json: schema: $ref: '#/components/schemas/EmptyResponse' '404': description: 'The traffic filter ruleset association cannot be found. (code: `traffic_filter.not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'Deletion failed. (code: `traffic_filter.request_execution_failed`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - traffic_filter.request_execution_failed type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - Traffic Filter - Associations '/deployments/{deployment_id}': get: tags: - Deployments summary: Get Deployment description: Retrieves information about a Deployment. operationId: get-deployment parameters: - name: deployment_id in: path description: Identifier for the Deployment required: true schema: type: string - name: show_security in: query description: Whether to include the Elasticsearch 2.x security information in the response - can be large per cluster and also include credentials schema: type: boolean default: false - name: show_metadata in: query description: Whether to include the full cluster metadata in the response - can be large per cluster and also include credentials schema: type: boolean default: false - name: show_plans in: query description: Whether to include the full current and pending plan information in the response - can be large per cluster schema: type: boolean default: true - name: show_plan_logs in: query description: Whether to include with the current and pending plan information the attempt log - can be very large per cluster schema: type: boolean default: false - name: show_plan_history in: query description: "Whether to include the plan history with the current and pending plan information. The results can be very large per cluster.\n By default, if a given resource kind (e.g. Elasticsearch, Kibana, etc.) has more than 100 plans\n (which should be very rare, most likely caused by a bug) only 100 plans are returned for the given resource type:\n The first 10 plans, and the last 90 plans for that resource type.\n If ALL of the plans are desired, pass the `force_all_plan_history` parameter with a value of `true`.\n" schema: type: boolean default: false - name: show_plan_defaults in: query description: 'If showing plans, whether to show values that are left at their default value (less readable but more informative)' schema: type: boolean default: false - name: convert_legacy_plans in: query description: 'If showing plans, whether to leave pre-2.0.0 plans in their legacy format (the default), or whether to update them to 2.0.x+ format (if ''true'')' schema: type: boolean default: false - name: show_system_alerts in: query description: Number of system alerts (such as forced restarts due to memory limits) to be included in the response - can be large per cluster. Negative numbers or 0 will not return field. schema: type: integer default: 0 - name: show_settings in: query description: Whether to show cluster settings in the response. schema: type: boolean default: false - name: show_instance_metrics in: query description: Whether to show resources instance metrics in the response. schema: type: boolean default: true - name: show_instance_configurations in: query description: 'If true, will return details for each instance configuration referenced by the deployment.' schema: type: boolean default: true - name: enrich_with_template in: query description: 'If showing plans, whether to enrich the plan by including the missing elements from the deployment template it is based on' schema: type: boolean default: true - name: force_all_plan_history in: query description: "Force show the entire plan history no matter how long.\n As noted in the `show_plan_history` parameter description, by default, a maximum of 100 plans are shown per resource. \n If `true`, this parameter overrides the default, and ALL plans are returned.\n Use with care as the plan history can be VERY large. Consider pairing with `show_plan_logs=false`.\n " schema: type: boolean default: false - name: clear_transient in: query description: 'If set (defaults to false) then removes the transient section from all child resources, making it safe to reapply via an update' schema: type: boolean default: false responses: '200': description: The Deployment info response headers: x-cloud-resource-version: description: 'The resource version, which is used to avoid update conflicts with concurrent operations' schema: type: string x-cloud-resource-created: description: The date-time when the resource was created (ISO format relative to UTC) schema: type: string x-cloud-resource-last-modified: description: The date-time when the resource was last modified (ISO format relative to UTC) schema: type: string content: application/json: schema: $ref: '#/components/schemas/DeploymentGetResponse' '401': description: You are not authorized to perform this action. content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - CRUD put: tags: - Deployments summary: Update Deployment description: Updates a Deployment. operationId: update-deployment parameters: - name: deployment_id in: path description: Identifier for the Deployment required: true schema: type: string - name: hide_pruned_orphans in: query description: Whether or not to hide orphaned resources that were shut down (relevant if prune on the request is true) schema: type: boolean default: false - name: skip_snapshot in: query description: Whether or not to skip snapshots before shutting down orphaned resources (relevant if prune on the request is true) schema: type: boolean default: false - name: validate_only in: query description: 'If true, will just validate the Deployment definition but will not perform the update' schema: type: boolean default: false - name: version in: query description: If specified then checks for conflicts against the version stored in the persistent store (returned in 'x-cloud-resource-version' of the GET request) schema: type: string requestBody: description: The deployment definition content: application/json: schema: $ref: '#/components/schemas/DeploymentUpdateRequest' required: true x-bodyName: body responses: '200': description: The request was valid and the deployment was updated. headers: x-cloud-resource-version: description: 'The resource version, which is used to avoid update conflicts with concurrent operations' schema: type: string x-cloud-resource-created: description: The date-time when the resource was created (ISO format relative to UTC) schema: type: string x-cloud-resource-last-modified: description: The date-time when the resource was last modified (ISO format relative to UTC) schema: type: string content: application/json: schema: $ref: '#/components/schemas/DeploymentUpdateResponse' '400': description: The deployment request had errors. content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '401': description: You are not authorized to perform this action. content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - CRUD '/deployments/{deployment_id}/_restore': post: tags: - Deployments summary: Restores a shutdown Deployment description: Restores all resources in a Deployment. operationId: restore-deployment parameters: - name: deployment_id in: path description: Identifier for the Deployment required: true schema: type: string - name: restore_snapshot in: query description: Whether or not to restore a snapshot for those resources that allow it. schema: type: boolean default: false responses: '200': description: The request was valid and the resources of the deployment were restored. content: application/json: schema: $ref: '#/components/schemas/DeploymentRestoreResponse' '400': description: There are Elasticsearch resources in the deployment which are not shut down. content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '401': description: You are not authorized to perform this action. content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - CRUD '/deployments/{deployment_id}/_shutdown': post: tags: - Deployments summary: Shuts down Deployment description: Shuts down all resources in a Deployment. operationId: shutdown-deployment parameters: - name: deployment_id in: path description: Identifier for the Deployment required: true schema: type: string - name: hide in: query description: Whether or not to hide the deployment and its resources.Only applicable for Platform administrators. schema: type: boolean - name: skip_snapshot in: query description: Whether or not to skip snapshots before shutting down the resources schema: type: boolean default: false responses: '200': description: The request was valid and the resources of the deployment were shutdown. content: application/json: schema: $ref: '#/components/schemas/DeploymentShutdownResponse' '400': description: 'Parameter is restricted and can only be set by a Platform administrator. (code: `deployments.restricted_parameter`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.restricted_parameter type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '401': description: You are not authorized to perform this action. content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - CRUD '/deployments/{deployment_id}/apm/{ref_id}': get: tags: - Deployments summary: Get Deployment APM Resource Info description: Get info about an APM Resource belonging to a given Deployment. operationId: get-deployment-apm-resource-info parameters: - name: deployment_id in: path description: Identifier for the Deployment required: true schema: type: string - name: ref_id in: path description: User-specified RefId for the Resource (or '_main' if there is only one). required: true schema: type: string - name: show_metadata in: query description: Whether to include the full cluster metadata in the response - can be large per cluster and also include credentials. schema: type: boolean default: false - name: show_plans in: query description: Whether to include the full current and pending plan information in the response - can be large per cluster. schema: type: boolean default: true - name: show_plan_logs in: query description: Whether to include with the current and pending plan information the attempt log - can be very large per cluster. schema: type: boolean default: false - name: show_plan_history in: query description: Whether to include with the current and pending plan information the plan history- can be very large per cluster. schema: type: boolean default: false - name: show_plan_defaults in: query description: 'If showing plans, whether to show values that are left at their default value (less readable but more informative).' schema: type: boolean default: false - name: show_settings in: query description: Whether to show cluster settings in the response. schema: type: boolean default: false - name: clear_transient in: query description: 'If set (defaults to false) then removes the transient section from all child resources, making it safe to reapply via an update' schema: type: boolean default: false responses: '200': description: Standard response. content: application/json: schema: $ref: '#/components/schemas/ApmResourceInfo' '404': description: 'The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'We have failed you. (code: `deployments.deployment_resource_no_longer_exists`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_resource_no_longer_exists type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - Info '/deployments/{deployment_id}/apm/{ref_id}/_reset-token': post: tags: - Deployments summary: Reset the secret token for an APM resource. description: Reset the token of an APM resource. operationId: deployment-apm-reset-secret-token parameters: - name: deployment_id in: path description: Identifier for the Deployment. required: true schema: type: string - name: ref_id in: path description: User-specified RefId for the Resource (or '_main' if there is only one). required: true schema: type: string responses: '202': description: 'Response containing the new secret token, plan to apply it starts' content: application/json: schema: $ref: '#/components/schemas/ApmCrudResponse' '400': description: 'Reset token is not supported when APM is managed by Elastic Agent. (code: `clusters.cluster_plan_state_error`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - clusters.cluster_plan_state_error type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: "* The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)\n* The Resource specified by {ref_id} cannot be found. (code: `deployments.deployment_resource_not_found`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found - deployments.deployment_resource_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'We have failed you. (code: `deployments.deployment_resource_no_longer_exists`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_resource_no_longer_exists type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: APM routes '/deployments/{deployment_id}/appsearch/{ref_id}': get: tags: - Deployments summary: Get Deployment App Search Resource Info description: Get info about an App Search Resource belonging to a given Deployment. operationId: get-deployment-appsearch-resource-info parameters: - name: deployment_id in: path description: Identifier for the Deployment required: true schema: type: string - name: ref_id in: path description: User-specified RefId for the Resource (or '_main' if there is only one). required: true schema: type: string - name: show_metadata in: query description: Whether to include the full cluster metadata in the response - can be large per cluster and also include credentials. schema: type: boolean default: false - name: show_plans in: query description: Whether to include the full current and pending plan information in the response - can be large per cluster. schema: type: boolean default: true - name: show_plan_logs in: query description: Whether to include with the current and pending plan information the attempt log - can be very large per cluster. schema: type: boolean default: false - name: show_plan_history in: query description: Whether to include with the current and pending plan information the plan history- can be very large per cluster. schema: type: boolean default: false - name: show_plan_defaults in: query description: 'If showing plans, whether to show values that are left at their default value (less readable but more informative).' schema: type: boolean default: false - name: show_settings in: query description: Whether to show cluster settings in the response. schema: type: boolean default: false - name: clear_transient in: query description: 'If set (defaults to false) then removes the transient section from all child resources, making it safe to reapply via an update' schema: type: boolean default: false responses: '200': description: Standard response. content: application/json: schema: $ref: '#/components/schemas/AppSearchResourceInfo' '404': description: 'The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'We have failed you. (code: `deployments.deployment_resource_no_longer_exists`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_resource_no_longer_exists type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - Info '/deployments/{deployment_id}/appsearch/{ref_id}/read_only_mode': get: tags: - Deployments summary: Set AppSearch read-only status description: Enable/Disable read-only mode on the given App Search resource. operationId: get-appsearch-read-only-mode parameters: - name: deployment_id in: path description: Identifier for the Deployment. required: true schema: type: string - name: ref_id in: path description: User-specified RefId for the Resource (or '_main' if there is only one). required: true schema: type: string responses: '200': description: Standard response content: application/json: schema: $ref: '#/components/schemas/ReadOnlyResponse' '404': description: 'The Resource specified by ref_id cannot be found. (code: `deployments.deployment_resource_not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_resource_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'We have failed you. (code: `deployments.deployment_resource_no_longer_exists`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_resource_no_longer_exists type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: App Search - Read-only put: tags: - Deployments summary: Set AppSearch read-only status description: Enable/Disable read-only mode on the given App Search resource. operationId: set-appsearch-read-only-mode parameters: - name: deployment_id in: path description: Identifier for the Deployment. required: true schema: type: string - name: ref_id in: path description: User-specified RefId for the Resource (or '_main' if there is only one). required: true schema: type: string requestBody: description: read-only request body content: application/json: schema: $ref: '#/components/schemas/ReadOnlyRequest' required: true x-bodyName: body responses: '200': description: Standard response content: application/json: schema: $ref: '#/components/schemas/ReadOnlyResponse' '404': description: 'The Resource specified by ref_id cannot be found. (code: `deployments.deployment_resource_not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_resource_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'We have failed you. (code: `deployments.deployment_resource_no_longer_exists`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_resource_no_longer_exists type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: App Search - Read-only '/deployments/{deployment_id}/byok-migration': post: tags: - Deployments summary: Migrate Deployment BYOK description: Migrate an existing deployment to use customer-managed encryption keys (BYOK). Currently unavailable in self-hosted ECE. operationId: migrate-deployment-byok parameters: - name: deployment_id in: path description: Identifier for the Deployment required: true schema: type: string requestBody: description: Request to migrate deployment to BYOK encryption content: application/json: schema: $ref: '#/components/schemas/ByokMigrationRequest' required: true x-bodyName: body responses: '200': description: BYOK migration request accepted. content: application/json: schema: $ref: '#/components/schemas/ByokMigrationResponse' '400': description: "* BYOK is not supported for system-owned deployments. (code: `byok_configuration.system_cluster_not_supported`)\n* The deployment has ILM policies using found-snapshots in cold/frozen phases. (code: `byok_migration.ilm_policy_conflict`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - byok_configuration.system_cluster_not_supported - byok_migration.ilm_policy_conflict type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '401': description: You are not authorized to perform this action. content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: 'The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '409': description: "* A different key is already configured on the deployment. (code: `byok_migration.key_mismatch`)\n* Another plan is pending on the deployment. (code: `deployments.resource_plan_state_error`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - byok_migration.key_mismatch - deployments.resource_plan_state_error type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: An error occurred while processing the request. content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployments - BYOK Migration '/deployments/{deployment_id}/certificate-authority': get: tags: - Deployments summary: Get certificate authority description: Returns the certificate authority used to sign the certificates of this deployment. operationId: get-deployment-certificate-authority parameters: - name: deployment_id in: path description: Identifier for the Deployment. required: true schema: type: string responses: '200': description: The certificate authority used to sign the certificates of this deployment content: application/json: schema: $ref: '#/components/schemas/CertificateAuthority' '404': description: "* The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)\n* The Elasticsearch Resource cannot be found. (code: `deployments.deployment_resource_not_found`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found - deployments.deployment_resource_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - Trust '/deployments/{deployment_id}/elasticsearch/{ref_id}': get: tags: - Deployments summary: Get Deployment Elasticsearch Resource Info description: Get info about an Elasticsearch Resource belonging to a given Deployment. operationId: get-deployment-es-resource-info parameters: - name: deployment_id in: path description: Identifier for the Deployment required: true schema: type: string - name: ref_id in: path description: User-specified RefId for the Resource (or '_main' if there is only one). required: true schema: type: string - name: show_security in: query description: Whether to include the Elasticsearch 2.x security information in the response - can be large per cluster and also include credentials. schema: type: boolean default: false - name: show_metadata in: query description: Whether to include the full cluster metadata in the response - can be large per cluster and also include credentials. schema: type: boolean default: false - name: show_plans in: query description: Whether to include the full current and pending plan information in the response - can be large per cluster. schema: type: boolean default: true - name: show_plan_logs in: query description: Whether to include with the current and pending plan information the attempt log - can be very large per cluster. schema: type: boolean default: false - name: show_plan_history in: query description: Whether to include with the current and pending plan information the plan history- can be very large per cluster. schema: type: boolean default: false - name: show_plan_defaults in: query description: 'If showing plans, whether to show values that are left at their default value (less readable but more informative).' schema: type: boolean default: false - name: convert_legacy_plans in: query description: 'If showing plans, whether to leave pre-2.0.0 plans in their legacy format (the default), or whether to update them to 2.0.x+ format (if ''true'').' schema: type: boolean default: false - name: show_system_alerts in: query description: Number of system alerts (such as forced restarts due to memory limits) to be included in the response - can be large per cluster. Negative numbers or 0 will not return field. schema: type: integer default: 0 - name: show_settings in: query description: Whether to show cluster settings in the response. schema: type: boolean default: false - name: enrich_with_template in: query description: 'If showing plans, whether to enrich the plan by including the missing elements from the deployment template it is based on.' schema: type: boolean default: true - name: clear_transient in: query description: 'If set (defaults to false) then removes the transient section from all child resources, making it safe to reapply via an update' schema: type: boolean default: false responses: '200': description: Standard response. content: application/json: schema: $ref: '#/components/schemas/ElasticsearchResourceInfo' '404': description: 'The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'We have failed you. (code: `deployments.deployment_resource_no_longer_exists`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_resource_no_longer_exists type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - Info '/deployments/{deployment_id}/elasticsearch/{ref_id}/_enable-ccr': post: tags: - Deployments summary: Migrate Elasticsearch and associated Kibana resources to enable CCR description: Migrates the specified Elasticsearch resource and its associated Kibana to enable CCR (if supported). operationId: enable-deployment-resource-ccr parameters: - name: deployment_id in: path description: Identifier for the Deployment. required: true schema: type: string - name: ref_id in: path description: User-specified RefId for the Resource (or '_main' if there is only one). required: true schema: type: string - name: validate_only in: query description: 'When `true`, will not enable CCR but returns warnings if any elements may lose availability during CCR enablement' schema: type: boolean default: false responses: '200': description: Standard response content: application/json: schema: $ref: '#/components/schemas/DeploymentResourceCommandResponse' '404': description: "* The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)\n* The Resource specified by {ref_id} cannot be found. (code: `deployments.deployment_resource_not_found`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found - deployments.deployment_resource_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - Commands '/deployments/{deployment_id}/elasticsearch/{ref_id}/_enable-ilm': post: tags: - Deployments summary: Migrate Elasticsearch resource to use ILM description: Migrates the specified Elasticsearch resource to use ILM. operationId: enable-deployment-resource-ilm parameters: - name: deployment_id in: path description: Identifier for the Deployment. required: true schema: type: string - name: ref_id in: path description: User-specified RefId for the Resource (or '_main' if there is only one). required: true schema: type: string - name: validate_only in: query description: 'When `true`, does not enable ILM but returns warnings if any applications may lose availability during ILM migration.' schema: type: boolean default: false requestBody: description: Information to build the ILM policies that will be created content: application/json: schema: $ref: '#/components/schemas/EnableIlmRequest' required: true x-bodyName: body responses: '200': description: Standard response content: application/json: schema: $ref: '#/components/schemas/DeploymentResourceCommandResponse' '404': description: "* The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)\n* The Resource specified by {ref_id} cannot be found. (code: `deployments.deployment_resource_not_found`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found - deployments.deployment_resource_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'We have failed you. (code: `deployments.deployment_resource_no_longer_exists`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_resource_no_longer_exists type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - Commands '/deployments/{deployment_id}/elasticsearch/{ref_id}/_enable-slm': post: tags: - Deployments summary: Migrate Elasticsearch resource to use SLM description: Migrates the specified Elasticsearch resource to use SLM. operationId: enable-deployment-resource-slm parameters: - name: deployment_id in: path description: Identifier for the Deployment. required: true schema: type: string - name: ref_id in: path description: User-specified RefId for the Resource (or '_main' if there is only one). required: true schema: type: string - name: validate_only in: query description: 'When `true`, does not enable SLM but returns warnings if any applications may lose availability during SLM migration.' schema: type: boolean default: false responses: '200': description: Standard response content: application/json: schema: $ref: '#/components/schemas/DeploymentResourceCommandResponse' '404': description: "* The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)\n* The Resource specified by {ref_id} cannot be found. (code: `deployments.deployment_resource_not_found`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found - deployments.deployment_resource_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'We have failed you. (code: `deployments.deployment_resource_no_longer_exists`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_resource_no_longer_exists type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - Commands '/deployments/{deployment_id}/elasticsearch/{ref_id}/_reset-password': post: tags: - Deployments summary: Reset 'elastic' user password description: Resets the password of the 'elastic' user. operationId: reset-elasticsearch-user-password parameters: - name: deployment_id in: path description: Identifier for the Deployment. required: true schema: type: string - name: ref_id in: path description: User-specified RefId for the Resource (or '_main' if there is only one). required: true schema: type: string - name: check_completion in: query description: 'If true, will not reset elastic user password and instead will return a status code signaling whether or not the current credentials are ready to use (eg from creation or the last call to _reset_password)' schema: type: boolean default: false responses: '200': description: The password reset was out carried successfully content: application/json: schema: $ref: '#/components/schemas/ElasticsearchElasticUserPasswordResetResponse' '404': description: "* The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)\n* The Resource specified by {ref_id} cannot be found. (code: `deployments.deployment_resource_not_found`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found - deployments.deployment_resource_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'Failed to reset the ''elastic'' user''s password. (code: `deployments.elasticsearch.password_reset_error`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.elasticsearch.password_reset_error type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - Commands '/deployments/{deployment_id}/elasticsearch/{ref_id}/_restart': post: tags: - Deployments summary: Restart Deployment Elasticsearch Resource description: 'Restarts an Elasticsearch Resource. If a Resource is active: this command re-applies the existing plan but applies a "cluster_reboot", which issues a restart command and waits for it to complete. If a Resource is inactive: this command starts it up with the most recent successful plan.' operationId: restart-deployment-es-resource parameters: - name: deployment_id in: path description: Identifier for the Deployment. required: true schema: type: string - name: ref_id in: path description: User-specified RefId for the Resource (or '_main' if there is only one). required: true schema: type: string - name: restore_snapshot in: query description: 'When set to true and restoring from shutdown, then will restore the cluster from the last snapshot (if available).' schema: type: boolean default: true - name: skip_snapshot in: query description: 'If true, will not take a snapshot of the cluster before restarting.' schema: type: boolean default: true - name: cancel_pending in: query description: 'If true, cancels any pending plans before restarting. If false and there are pending plans, returns an error.' schema: type: boolean default: false - name: group_attribute in: query description: 'Indicates the property or properties used to divide the list of instances to restart in groups. Valid options are: ''\_\_all\_\_'' (restart all at once), ''\_\_zone\_\_'' by logical zone, ''\_\_name\_\_'' one instance at a time, or a comma-separated list of attributes of the instances' schema: type: string default: __zone__ - name: shard_init_wait_time in: query description: 'The time, in seconds, to wait for shards that show no progress of initializing, before rolling the next group (default: 10 minutes)' schema: type: integer default: 600 responses: '202': description: The restart command was issued successfully. content: application/json: schema: $ref: '#/components/schemas/DeploymentResourceCommandResponse' '404': description: "* The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)\n* The Resource specified by {ref_id} cannot be found. (code: `deployments.deployment_resource_not_found`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found - deployments.deployment_resource_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '422': description: 'The command sent to a Resource found the Resource in an illegal state, the error message gives more details. (code: `deployments.deployment_resource_plan_change_error`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_resource_plan_change_error type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'A Resource that was previously stored no longer exists. (code: `deployments.deployment_resource_no_longer_exists`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_resource_no_longer_exists type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - Commands '/deployments/{deployment_id}/elasticsearch/{ref_id}/_shutdown': post: tags: - Deployments summary: Shutdown Deployment Elasticsearch Resource description: Shutdown Elasticsearch Resource belonging to a given Deployment. operationId: shutdown-deployment-es-resource parameters: - name: deployment_id in: path description: Identifier for the Deployment. required: true schema: type: string - name: ref_id in: path description: User-specified RefId for the Resource (or '_main' if there is only one). required: true schema: type: string - name: hide in: query description: Hide cluster on shutdown. Hidden clusters are not listed by default. Only applicable for Platform administrators. schema: type: boolean - name: skip_snapshot in: query description: 'If true, will skip taking a snapshot of the cluster before shutting the cluster down (if even possible).' schema: type: boolean default: false responses: '200': description: Standard response. content: application/json: schema: $ref: '#/components/schemas/DeploymentResourceCommandResponse' '400': description: 'Parameter is restricted and can only be set by a Platform administrator. (code: `deployments.restricted_parameter`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.restricted_parameter type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: "* The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)\n* The Resource specified by {ref_id} cannot be found. (code: `deployments.deployment_resource_not_found`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found - deployments.deployment_resource_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '500': description: 'A Resource that was previously stored no longer exists. (code: `deployments.deployment_resource_no_longer_exists`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_resource_no_longer_exists type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - Commands '/deployments/{deployment_id}/elasticsearch/{ref_id}/eligible-remote-clusters': post: tags: - Deployments summary: Get eligible remote clusters description: Returns the list of deployments which contain eligible remote clusters for the elasticsearch resource. operationId: get-deployment-es-resource-eligible-remote-clusters parameters: - name: deployment_id in: path description: Identifier for the Deployment. required: true schema: type: string - name: ref_id in: path description: User-specified RefId for the Resource (or '_main' if there is only one). required: true schema: type: string requestBody: description: '(Optional) The search query to run against all deployments containing eligible remote clusters. When not specified, all the eligible deployments are matched.' content: application/json: schema: $ref: '#/components/schemas/SearchRequest' x-bodyName: body responses: '200': description: List of deployments which contains eligible remote clusters for the resource content: application/json: schema: $ref: '#/components/schemas/DeploymentsSearchResponse' '400': description: 'The resource specified doesn''t yet have a valid version for the current plan or the pending plan. (code: `deployments.resource_does_not_have_a_valid_version`)' headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.resource_does_not_have_a_valid_version type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' '404': description: "* The Deployment specified by {deployment_id} cannot be found. (code: `deployments.deployment_not_found`)\n* The Resource specified by {ref_id} cannot be found. (code: `deployments.deployment_resource_not_found`)" headers: x-cloud-error-codes: description: The error codes associated with the response schema: enum: - deployments.deployment_not_found - deployments.deployment_resource_not_found type: string content: application/json: schema: $ref: '#/components/schemas/BasicFailedReply' x-doc: tag: Deployment - Remote Clusters '/deployments/{deployment_id}/elasticsearch/{ref_id}/keystore': get: tags: - Deployments summary: Get the items in the Elasticsearch resource keystore description: Fetches the current fields and metadata (but not the values) of the keystore for the Elasticsearch resource. operationId: get-deployment-es-resource-keystore parameters: - name: deployment_id in: path description: Identifier for the Deployment required: true schema: type: string - 
[...]
